<?php

/**
 * Implement an argument handler which loads both the terms and the
 * descendent terms for a loaded node.
 */
class views_related_nodes_plugin_argument_default_taxonomy_tid_descendent extends views_plugin_argument_default_taxonomy_tid {
  function get_argument() {
    $arg = parent::get_argument();
    $args = explode(',', $arg);
    $tids = $this->get_all_term_children($args);
    return implode('+', $tids);
  }

  function get_all_term_children($tids) {
    $childtids = array();
    while ($tid = array_pop($tids)) {
      $children = array_keys(taxonomy_get_children($tid));
      $tids = array_merge($tids, $children);
      $childtids[] = $tid;
    }
    return $childtids;
  }
}
